﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using CDays2013.Settings.Settings;
using Callisto.Controls;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Storage;
using Windows.UI;
using Windows.UI.ApplicationSettings;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Basic Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234237

namespace CDays2013.Settings
{
    /// <summary>
    /// A basic page that provides characteristics common to most applications.
    /// </summary>
    public sealed partial class MainPage : CDays2013.Settings.Common.LayoutAwarePage
    {
        public MainPage()
        {
            this.InitializeComponent();
            SettingsPane.GetForCurrentView().CommandsRequested += MainPage_CommandsRequested;
        }

        void MainPage_CommandsRequested(SettingsPane sender, SettingsPaneCommandsRequestedEventArgs args)
        {
            SettingsCommand supportCommand = new SettingsCommand("Support", "Support", (x) =>
            {
                SettingsFlyout settings = new SettingsFlyout();
                settings.ContentBackgroundBrush = new SolidColorBrush(Colors.Black);
                settings.HeaderBrush = new SolidColorBrush(Colors.White);
                settings.Content = new SupportPage();
                settings.HeaderText = "Support";
                settings.IsOpen = true;
            });

            args.Request.ApplicationCommands.Add(supportCommand);
        }

        private void ButtonBase_OnClick(object sender, RoutedEventArgs e)
        {
            if (ApplicationData.Current.LocalSettings.Values.ContainsKey("IsEnabled"))
            {
                bool b = (bool)ApplicationData.Current.LocalSettings.Values["IsEnabled"];
                SelectedValue.Text = b.ToString();
            }
        }

        void pageRoot_GotFocus(object sender, RoutedEventArgs e)
        {
            if (ApplicationData.Current.LocalSettings.Values.ContainsKey("IsEnabled"))
            {
                string value = ApplicationData.Current.LocalSettings.Values["IsEnabled"].ToString();
                SelectedValue.Text = value;
            }
        }

        /// <summary>
        /// Populates the page with content passed during navigation.  Any saved state is also
        /// provided when recreating a page from a prior session.
        /// </summary>
        /// <param name="navigationParameter">The parameter value passed to
        /// <see cref="Frame.Navigate(Type, Object)"/> when this page was initially requested.
        /// </param>
        /// <param name="pageState">A dictionary of state preserved by this page during an earlier
        /// session.  This will be null the first time a page is visited.</param>
        protected override void LoadState(Object navigationParameter, Dictionary<String, Object> pageState)
        {
        }

        /// <summary>
        /// Preserves state associated with this page in case the application is suspended or the
        /// page is discarded from the navigation cache.  Values must conform to the serialization
        /// requirements of <see cref="SuspensionManager.SessionState"/>.
        /// </summary>
        /// <param name="pageState">An empty dictionary to be populated with serializable state.</param>
        protected override void SaveState(Dictionary<String, Object> pageState)
        {
        }
    }
}
